import invariant from 'graphql/jsutils/invariant';
import { GraphQLNonNull } from './graphql';
import { isNamedTypeComposer } from './utils/typeHelpers';
import { ListComposer } from './ListComposer';
export class NonNullComposer {
  constructor(type) {
    invariant(!(type instanceof NonNullComposer), 'You provide NonNull value to NonNullCOmposer constructor. Nesting NonNull is not allowed.');
    this.ofType = type; // alive proper Flow type casting in autosuggestions for class with Generics

    /* :: return this; */
  }

  getType() {
    return new GraphQLNonNull(this.ofType.getType());
  }

  getTypeName() {
    return `${this.ofType.getTypeName()}!`;
  }

  getUnwrappedTC() {
    let tc = this;

    while (!isNamedTypeComposer(tc)) {
      tc = tc.ofType;
    }

    return tc;
  }

  getTypePlural() {
    return new ListComposer(this);
  }

  getTypeNonNull() {
    return this;
  }

}