import { GraphQLList } from './graphql';
import { isNamedTypeComposer } from './utils/typeHelpers';
import { NonNullComposer } from './NonNullComposer';
export class ListComposer {
  constructor(type) {
    this.ofType = type; // alive proper Flow type casting in autosuggestions for class with Generics

    /* :: return this; */
  }

  getType() {
    return new GraphQLList(this.ofType.getType());
  }

  getTypeName() {
    return `[${this.ofType.getTypeName()}]`;
  }

  getUnwrappedTC() {
    let tc = this;

    while (!isNamedTypeComposer(tc)) {
      tc = tc.ofType;
    }

    return tc;
  }

  getTypePlural() {
    return new ListComposer(this);
  }

  getTypeNonNull() {
    return new NonNullComposer(this);
  }

}